Subject: Re: [PATCH] niu: fix SMP race protecting rx_rings and tx_rings

From: Flavio Leitner <[email-masked]>
Date: Thu, 3 Feb 2011 21:47:48 -0200

On Thu, Feb 03, 2011 at 03:22:14PM -0800, David Miller wrote:
> From: Flavio Leitner <[email-masked]>
> Date: Thu, 3 Feb 2011 21:18:05 -0200
> 
> > Ok, I can write a new version using RCU if you like.
> 
> Don't worry, I'll take care of it, I actually have the
> hardware to test on :-)

Ok. Having the hardware around indeed helps :)

> > I've chose rwsem because I think those operations aren't
> > frequent. The RCU leaves an operation to run later during
> > a safe context, so I thought the cost doesn't worth it.
> 
> One thing I'm worried about with your patch is that the statistics
> method can be called in basically any context, therefore a sleeping
> lock like the rw_semaphore is probably not usable.
> 
> In fact I'm going to revert your patch for now because of this issue.

Oops, I didn't see it there.  I thought all calls there were process
context.  Anyway, RCU then...

thanks for reviewing it,
-- 
Flavio